
usage = """Usage: python fileArranger.py <prefix> <optional -create_sample> file1 file2 ... fileN

 All files have to processed in the same pass.  You need more than 
 one file to do anything useful.

 This program creates two outputs.  It produces a 
 java script file that will can be loaded in a 
 html file to generate a random file name conforming 
 to a naming convention.
    -The name of this script will be <prefix>_gen.js
    -The name of the random file name java script variable is <prefix>_RND
 -------------------
  
 It also creates a series of translated java script 
 files that can be loaded into added into an 
 html document simply by including it as a java script.
   -These files will be named <prefix>_X.js, where X is an integer.
   -Embedded HTML is passed through to the browser.
   -New lines are translated to a <br> tag.
 --------------------
 
 If the first file name is <-create_sample> a test.html and a proof.html
 page will be created to show generated script usage.
 
 
"""

import sys
import os
import glob
import string

if len( sys.argv ) < 3 :
	print usage
	sys.exit(-1)
	


"""
------------------------------------------------------- 

  S E T U P   G L O B A L   V A R I B L E S 
 
------------------------------------------------------- 
"""

def create_file_list():
	"""
	XP is not properly expanding file wildcards 
	before invoking python.  
	Lucky for us, glob does this as well...
	I've tried this on XP cmd.exe and Cygwin bash.
	"""
	f_list = []
	t_list = sys.argv[ 2 : len(sys.argv)]	
	for file_pattern in t_list:
		for found_files in glob.glob( file_pattern ):
			f_list.append(found_files)
	return f_list
		


prefix = sys.argv[1]	

if sys.argv[2] == "-create_sample":
	skip_sample = 0;
else:
	skip_sample = 1;


file_list = create_file_list() 
file_count = len( file_list )


java_script_warning = """// !!!
// DO NOT MODIFY THIS SCRIPT DIRECTLY
// IT WAS AUTOMATICALLY GENERATED BY 
// THE "FILEARRANGER.PY" SCRIPT.
// !!!
"""
rnv_script_name = prefix + "_gen.js"


	

	

"""
---------------------------------------------------------------

  G E N E R A T E    R N D   N U M   V A R   S C R I P T 
 
--------------------------------------------------------------- 
"""

def gen_switch_block():
	block = []
	i = 0
	for file in file_list:
		include_filename = "%s_%d.js" % (prefix,i )
		block.append( "	     case %d: " % i )
		block.append( "           document.write('<script src=\"%s\" > </script>') " % include_filename )
		block.append( "           break" )
		block.append( "" )
		i = i + 1
	return string.join( block, "\n" )
		


f = open( rnv_script_name, 'w')
f.write( """
%s
var randomRange = %d ;
var %s_RND = Math.floor( Math.random() * randomRange ) 

function insert_%s_text( text_number ) {

	switch( text_number )
	{
	     %s
	}

}

function insert_random_%s_text() {
	insert_%s_text( %s_RND )
}



""" % (java_script_warning, file_count , prefix, prefix, gen_switch_block(), prefix, prefix, prefix) )
f.close()





"""
---------------------------------------------------------------

  T R A N S L A T E   E A C H   I N P U T   F I L E
 
--------------------------------------------------------------- 
"""

	
def translate_file( input_filename, filecount ):
	output_filename = "%s_%d.js" % (prefix,filecount )
	f_in = open( input_filename, 'r')
	f_out= open( output_filename, 'w')
	f_out.write( java_script_warning )
	lines = f_in.readlines()
	for line in lines: 
		line = string.replace( line,"\n", "")
		line = string.replace( line, "'", "\\'" )
		f_out.write( "document.write('" + line + "<br>')\n" )
	f_in.close()
	f_out.close()
		
	


i = 0
for file in file_list:
	translate_file( file, i )
	i = i + 1







if skip_sample:
	# delete if already exist.
	rmv_list = []
	rmv_list = glob.glob( "test.html" ) + glob.glob("proof.html")
	for file in rmv_list:
		os.remove(file)
	
	# exit early.
	sys.exit(0)


"""
---------------------------------------------------------------

  G E N E R A T E    T E S T   H T M L   F I L E 
 
--------------------------------------------------------------- 
"""
f = open( "test.html", 'w' )
f.write( """<html>
<head>
	<title>Test %s included text java script</title>
</head>
<body>
	<h1>Test <font color="FF0000">%s</font> included text java script</h1>
	<p><i>Created by FileArranger.py :)<br>
        </i><a href="http://www.gideonrasmussen.com/sectips">http://www.gideonrasmussen.com/sectips</a>	
</p>
	<hr>
<script src ="%s"></script>
<script type="text/javascript">
	document.write( "<p><b>Load test file: " + (%s_RND + 1) + "</b></p>" )
</script>
<hr>
<script type="text/javascript">
	insert_random_%s_text()
</script>

</p>

</body>
</html>
""" % ( prefix, prefix, rnv_script_name, prefix, prefix)) 
f.close()


"""
---------------------------------------------------------------

  G E N E R A T E    P R O O F   H T M L   F I L E 
 
--------------------------------------------------------------- 
"""
f = open( "proof.html", 'w' )
f.write( """<html>
<head>
	<title>Include all %s text files to proof read:</title>
</head>
<body>
<script src ="%s"></script>
<h1>Include all <font color="FF0000">%s</font> text files to proof read:</h1>
<p><i>Created by FileArranger.py :)<br>
</i><a href="http://www.gideonrasmussen.com/sectips">http://www.gideonrasmussen.com/sectips</a>		
</p>
<table border="3" cellpadding="15" >
<b>
<tr>
<th width="15%%"><em><b>ORIGINAL FILE NAME:</b></em></td>
<th width="15%%"><em><b>TRANSLATED FILE NAME:</b></em></td>
<th><em><b>TEXT WHEN INCLUDED:</b></em></td>
</tr>
</b>


""" % ( prefix, rnv_script_name, prefix ) )

i = 0
for file in file_list:
	include_filename = "%s_%d.js" % (prefix,i )
	i = i + 1
	f.write( "<tr>\n" )
	f.write( "<td>%s</td>\n" % file )
	f.write( "<td>%s</td>\n" % include_filename )
	f.write( "<td><script src=\"%s\"></script></td>\n" % include_filename )
	f.write( "</tr>\n" )
	

f.write( """
</table>
</body>
</html>
""" ) 
f.close()



